/**
 * Speedloader logic
 */

var HOSTED_SPEEDLOADER_PREFIX = "versions/v_";
var CUSTOM_SPEEDLOADER_PREFIX = "eMagStudio_versions/ver_";
var UIDS = "uids";

var locationHREF = window.location.href;
var readerURLVar = "";
var pubDataURLVar = "";
var flashvars = {};

if (useHostedSpeedloaderVar) {
	speedloaderURLVar = "http://sl.readertracking.com/";
	speedloaderUIDSURLVar = speedloaderURLVar + "uids/"; 
}

if (useSpeedloaderVar) {
	//alert("we use speedloader");
	if (thisRunsLocally()) {
		//alert("runs localy");
		standardReaderFlashVars();
		embedReader();
	} else {
		//alert("runs from remote");
		if (useHostedSpeedloaderVar) {
			checkUIDOnHostedSpeedloaderServer();
		} else {
			checkCustomSpeedloaderServer();
		}
	}
} else {
	//alert("we do not use speedloader");
	standardReaderFlashVars();
	embedReader();
}

function thisRunsLocally() {
	if (locationHREF.indexOf("file") >= 0) {
		return true;
	} else {
		return false;
	}
}

function checkUIDOnHostedSpeedloaderServer() {
	var uIDFileURL = speedloaderUIDSURLVar + uidVar + ".jpg";
	//alert(uIDFileURL);
	var image = new Image();
	image.onload = function() {
		//alert('OK for UID');
		checkHostedSpeedloaderServer();
	};
	image.onerror = function() {
		//alert('ERROR for UID');
		standardReaderFlashVars();
		embedReader();
	};
	image.src = uIDFileURL;
}

function checkHostedSpeedloaderServer() {
	var testImageURL = speedloaderURLVar + HOSTED_SPEEDLOADER_PREFIX + eMagStudioVersionVar + "/test.jpg";
	var image = new Image();
	image.onload = function() {
		//alert('OK for server check');
		hostedSpeedloaderReaderFlashVars();
		embedReader();
	};
	image.onerror = function() {
		//alert('ERROR for server check');
		standardReaderFlashVars();
		embedReader();
	};
	image.src = testImageURL;
}

function checkCustomSpeedloaderServer() {
	var testImageURL = speedloaderURLVar + CUSTOM_SPEEDLOADER_PREFIX + eMagStudioVersionVar + "/test.jpg";
	var image = new Image();
	image.onload = function() {
		//alert('OK for server check');
		customSpeedloaderReaderFlashVars();
		embedReader();
	};
	image.onerror = function() {
		//alert('ERROR for server check');
		standardReaderFlashVars();
		embedReader();
	};
	image.src = testImageURL;
}

function standardReaderFlashVars() {
	//alert("passing in standard flash vars");
	useSpeedloaderVar = false;
	readerURLVar = "reader.swf";
	pubDataURLVar = "pubData/";
	fillInFlashVars();
}

function hostedSpeedloaderReaderFlashVars() {
	//alert("passing in hosted speedloader flash vars");
	useSpeedloaderVar = true;
	useHostedSpeedloaderVar = true;
	readerURLVar = speedloaderURLVar + HOSTED_SPEEDLOADER_PREFIX + eMagStudioVersionVar + "/reader.swf";
	pubDataURLVar = locationHREF.substring(0, locationHREF.indexOf("index")) + "pubData/";
	fillInFlashVars();
}

function customSpeedloaderReaderFlashVars() {
	//alert("passing in custom speedloader flash vars");
	useSpeedloaderVar = true;
	useHostedSpeedloaderVar = false;
	readerURLVar = speedloaderURLVar + CUSTOM_SPEEDLOADER_PREFIX + eMagStudioVersionVar + "/reader.swf";
	pubDataURLVar = locationHREF.substring(0, locationHREF.indexOf("index")) + "pubData/";
	fillInFlashVars();
}

function fillInFlashVars() {
	flashvars = {useSpeedloader: useSpeedloaderVar,
				 useHostedSpeedloader: useHostedSpeedloaderVar,
				 speedloaderURL: speedloaderURLVar,
				 eMagStudioVersion: eMagStudioVersionVar,
				 pubDataURL: pubDataURLVar};
}

function embedReader() {
	//alert("embedding");
	var params = {};
	params.scale = "default";
	params.allowScriptAccess = "always";
	params.swliveconnect = "true";
	params.classid = "clsid:d27cdb6e-ae6d-11cf-96b8-444553540000";
	params.pluginspage = "http://www.adobe.com/go/getflashplayer";
	params.type = "application/x-shockwave-flash";
	params.base = "";
	params.wmode = "window";
	params.bgcolor = "#cccccc";
	params.allowFullscreen = "true";
	var attributes = {};
	attributes.id = "eMag";
	attributes.name = "eMag";
	swfobject.embedSWF(readerURLVar, "eMag", "100%", "100%", "9.0.0", pubDataURLVar + "expressInstall.swf", flashvars, params, attributes);
	//alert("embeded");
}